/*
   FIlename: s1500.java
   Class: s1500
   Other class: shareddata3
   Note: ƥȥץ
   Test No.: s150001
   Last update: 2000/1/20

Copyright(C) 1999-2000
TOSHIBA INFORMATION SYSTEMS(JAPAN) CORPORATION. All Rights Reserved.
*/
import jp.gr.itron.jtron.shared.* ;

public class s1500 extends Thread
{
  // variable
  static shareddata3 sdata1 = null ;
  static s1500 th1 ;
  private ThreadGroup ptg ;

  // constructor
  s1500 (ThreadGroup parent, String thname)
  {
    super (parent, thname) ;
    System.out.println ("(s1500)[C] Enter: s1500") ;
    ptg = parent ;
  }

  public void run () {

    String thn, tgn ;

    thn = getName () ;
    tgn = ptg.getName () ;
    System.out.println ("(s1500)(r) Enter: run: thn: "+thn+", tgn:"+tgn) ;

    System.out.println ("(s1500)(r): ----- suspend ------: "+tgn) ;
    ptg.suspend () ;

    try {
	System.out.println ("(s1500)(r): [Java] 7.1.5.2 (F) =====> lock <=====") ;
	sdata1.lock () ;
    } catch (ShmIllegalStateException ex) {
	System.out.println ("(s1500)(r) catch: "+ex+", code: "+ex.getCause ()) ;
    }

    try {
	System.out.println ("(s1500)(r): ----- sleep 5000ms ------: "+thn) ;
	sleep (5000) ;
    } catch (Exception e) {}

    try {
	System.out.println ("(s1500)(r): [Java] 7.1.5.2 (G) <===== unlock =====>") ;
	sdata1.unlock () ;
	} catch (ShmIllegalStateException ex) {
	  System.out.println ("(s1500)(r) catch: "+ex+", code: "+ex.getCause ()) ;
    }

    try {
	System.out.println ("(s1500)(r): [Java] 7.1.5.1 (B) ===== unshare =====") ;
	sdata1.unshare () ;
	} catch (ShmIllegalStateException ex) {
	  System.out.println ("(s1500)(r) catch: "+ex+", code: "+ex.getCause ()) ;
    }

    for (int i=0; i < 100; i++) {
      System.out.println ("(s1500)(r) ==> "+thn+":["+(i+1)+"/100]") ;
      try {
	sleep (500) ;
      } catch (Exception e) {}
    }
  }

  // main
  public static void main (String args[])
  {
    System.out.println ("(s1500)(main) Enter: main") ;
    System.out.println ("(s1500) s150001 - A1") ;

    try {     // ֥ͭȤ
      System.out.println ("(s1500)(r): [Java] 7.1.5.1 (A) ===== share =====") ;
      sdata1 = new shareddata3 ("Shared_Object", 2000) ;
    } catch (ShmIllegalStateException ex) {
      System.out.println ("(s1500)[C] catch: "+ex+", code: "+ex.getCause ()) ;
      System.exit (1) ;
    }

    ThreadGroup thg = new ThreadGroup ("Shared_Thread_Group") ;
    th1 = new s1500 (thg, "Shared_Thread") ;
    th1.start () ;

    System.out.println ("(s1500)(main) Exit: main") ;
  }
}
