/*
  ȥ꡼ൡǽ ƥȥץ
  λ

*/
/*
 *  s1600
 *    Copyright(C) 1999-2000 
 *    TOSHIBA INFORMATION SYSTEMS(JAPAN) CORPORATION. All Rights Reserved.
 */

#include	<basic.h>
#include	<bstring.h>
#include	<tstring.h>
#include	<inner.h>
#include	<bstdio.h>

#include	<jcg/i_jt2ext.h>

#define printf minprintf
void minprintf(char *fmt,...);

#define STMID           4

/*
	
*/
#define	DEFAULT_PRI	(120)		/* ǥեͥ		*/
#define	TASK_STKSZ	(2048)		/* å		*/

LOCAL	W	running1 = 0;		/* ¹ե饰			*/
LOCAL	W	running2 = 0;		/* ¹ե饰			*/

LOCAL ID mbxid=5;

typedef struct my_msg {
  VP      msgque[1];      /* å塼ΤΥꥢ */
  PRI     msgpri;         /* åͥ */
  INT     msgsiz;         /* å */
  VB      msgcont[10];    /* å */
} MY_MSG;

/*
    ȥ꡼ITRON¦
*/
LOCAL	VOID	test_task1(VOID)
{
  ER		er,er1;
  W		i, cnt;
  ID		tskid;
  T_JTI_CSTM	cstm;
  T_JTI_RSTM	rstm;
  UB		buf[256]="->ITRON2JAVA->";
  char cbuf;

  SYSTIME pk_stim,pk_tim,*ppk_tim;

  LOCAL T_CMBX cmbx;
  MY_MSG t_msg;
  T_RMBX rmbx;

  int stdtim;
  running1 = 1;
  
  get_tid(&tskid);
  printf("# tskid = %d\n", tskid);

  /* ᥤܥåκ Java¦˥ƥ೫ϻ֤롣 */
  cmbx.mbxatr=TA_MFIFO;
  er=cre_mbx(mbxid,&cmbx);
  if(er >= E_OK){
    printf("tskB:cre_mbx OK:%d\n",er);
  } else{
    printf("tskB:cre_mbx ERR:%d\n",er);
    return;
  }
  er = get_tim(&pk_tim);
  pk_stim=pk_tim;
  t_msg.msgsiz=8;
  ppk_tim=(SYSTIME *)&t_msg.msgcont[0];
  *ppk_tim=pk_tim;
  er=snd_msg(mbxid,(T_MSG*)&t_msg);
  if(er >= E_OK){
    printf("tskB:snd_msg OK:%d\n",er);
  } else{
    printf("tskB:snd_msg ERR:%d\n",er);
    return;
  }

  /* ȥ꡼ */
  cstm.exinf = 0;
  cstm.stmattr = TA_READ | TA_WRITE;
  cstm.wbuf = NADR;
  cstm.wbufsz = 16;
  cstm.rbuf = NADR;
  cstm.rbufsz = 16;
  er = jti_cre_stm(STMID, &cstm);
  er = get_tim(&pk_tim);
  printf("# time(jti_cre_stm)=%d\n", pk_tim-pk_stim);
  printf("# jti_cre_stm er = %d\n", er);
  if (er < 0) goto EEXIT;

  /* ǡ */
  for (cnt = 0; cnt < strlen(buf); cnt++) {
    dly_tsk(cnt * 200);
    er = get_tim(&pk_tim);
    printf("# c=%c time=%d\n",buf[cnt], (pk_tim-pk_stim));
    if( cnt==6 ) {
      /* ֻ */
      er = jti_ref_stm(STMID, &rstm);
      printf("# jti_ref_stm wrisz = %d, reasz = %d er = %d\n",
	 rstm.wrisz, rstm.reasz, er);
    }
    er = jti_wri_stm(STMID, &buf[cnt], 1, TMO_FEVR);
    if (er <= 0) break;
  }

  dly_tsk(5 * 1000);

  for (cnt = 0; cnt < 14; cnt++) {

    er1 = get_tim(&pk_tim);
    er = jti_rea_stm(STMID, &cbuf, 1, TMO_FEVR);
    printf("# c=%c time=%d\n",cbuf, (pk_tim-pk_stim));

  }


  dly_tsk(2 * 1000);

  /* ȥ꡼९ */
  er = jti_sht_stm(STMID);
  printf("# jti_sht_stm er = %d\n", er);

  /* ȥ꡼κ */
  er = jti_del_stm(STMID);
  printf("# jti_del_stm er = %d\n", er);

EEXIT:

  running1 = 0;
  exd_tsk();
}

/*
	 / ư
*/
LOCAL	WERR	CreateTask(FP entry, PRI pri)
{
  ERR	er;
  ID	tskid;
  T_CTSK	ctsk;

  /*  */
  ctsk.task    = entry;
  ctsk.itskpri = pri;
  ctsk.stksz   = TASK_STKSZ;
  ctsk.tskatr  = TA_HLNG | TA_RNG0;
  er = vcre_tsk(&ctsk);
  if (er >= E_OK) {
    /* ư */
    tskid = (ID)er;
    er = sta_tsk(tskid, 0);
    if (er >= E_OK) return tskid;
    del_tsk(tskid);
  }
  return er;
}
/*
	ȥå
*/
ERR	main(Bool Startup, TC *arg)
{
  static	ID	tskid1, tskid2;
  W	i;

  if (Startup) {		/* ư */
    printf("# started\n");
    
    tskid1 = CreateTask(test_task1, DEFAULT_PRI);
    if (tskid1 < 0) return tskid1;

    return E_OK;
  }

  /* λ */
  for (i = 50; --i >= 0; dly_tsk(100)) {
    if (running1 == 0 ) break;
  }
  if (running1 > 0) {ter_tsk(tskid1); del_tsk(tskid1);}
  
  printf("# finished\n");
  return E_OK;

}

void minprintf(char *fmt,...) {

  va_list ap;
  char *p,*sval;
  char c;
  int ival;
  double dval;
  char buf[32];

  va_start(ap,fmt);

  for(p=fmt;*p;p++) {
    if(*p != '%' ) {
      _PutChar(*p);
      continue;
    }
    
    switch (*++p) {
    case 'd':
      ival = va_arg(ap,int);
      sprintf(buf,"%d",ival);
      _PutString(buf);
      break;
    case 'f':
      dval = va_arg(ap,double);
      sprintf(buf,"%f",dval);
      _PutString(buf);
      break;
    case 'c':
      c = va_arg(ap,char);
      _PutChar(c);
      break;  
    case 's':
      for(sval = va_arg(ap,char *);*sval;sval++) {
        _PutChar(*sval);
      }
      break;
    default:
      _PutChar(*p);
      break;
    }

  }

  va_end(ap);

}
