import jp.gr.itron.jtron.stream.*;
import jp.gr.itron.jtron.attach.*;

import java.io.*;
import java.lang.InterruptedException;

/*
 *  s1600
 *    Copyright(C) 1999-2000 
 *    TOSHIBA INFORMATION SYSTEMS(JAPAN) CORPORATION. All Rights Reserved.
 */
/*
  λ
 */

public class s1600 {

  //  main  
  public static void main(String[] args) {

    // ȥ꡼
    JtiDataStream jst;

    // ȥ꡼༱̻
    int stmid=4;

    InputStream is = null;
    OutputStream os = null;
    String str;

    MailBox mbx=null;
    int mbxid=5;
    Long l = new Long(0);    
    ItronMemory im=null;
    int rv;
    long stime=0;

    /* ITRONץꥱ󥿥¹Գϻ֤롣 */
    try {
      mbx = new MailBox(mbxid);
      im=mbx.receive(12);

      int ivalue=im.readInt();

      // stime:ITRONץꥱ󥿥¹Գϻ
      stime=im.readLong();

      System.out.println("java:ITRON START TIME="+stime);

      /* ᡼ܥå */
      mbx.delete();

      rv = ItronApi.get_tim(l);
      System.out.println("ItronApi.get_tim() l="+(l.longValue()-stime));

    } catch (JTRONException e) {
      System.out.println("catch JTRONException SND MBX");
    }


    try {

      // ȥ꡼³
      jst = new JtiDataStream(stmid);
      System.out.println("STREAM OPEN OK");

      Thread.sleep(1*1000);

      // ॢȻ֤
      jst.setIDSTimeOut(10000);
      int tmout=jst.getIDSTimeOut();
      System.out.println("tmout="+tmout);

      // InputStreamμ
      is = jst.getInputStream();
      System.out.println("getInputStream() OK");      

      int c;

      Thread.sleep((long)4.5*1000);
      rv = ItronApi.get_tim(l);
      System.out.println("time(read() start)="+(l.longValue()-stime));

      // ɤ߹
      while( ( c = is.read() ) > 0 ) { 
	  rv = ItronApi.get_tim(l);
	  System.out.println("C="+(char)c+" TIME()="+(l.longValue()-stime));
      }

      // OutputStreamμ
      os = jst.getOutputStream();
      System.out.println("getOutputStream() OK");   

      // 񤭹
      str="<-JAVA2ITRON<-";
      rv = ItronApi.get_tim(l);
      System.out.println("ItronApi.get_tim() l="+(l.longValue()-stime));
      byte [] ba = str.getBytes();

      for(int i=0;i<ba.length;i++) {
	Thread.sleep(i*100);
	System.out.println("C= "+(char)ba[i]+" TIME="+(l.longValue()-stime));
        os.write(ba,i,1);
        rv = ItronApi.get_tim(l);
      }

      Thread.sleep(10*1000);

    } catch ( JtiDataStreamException e ) {
      System.out.println("JtiDataStreamException:");
      System.out.println("  msg="+e.getMessage());
      System.out.println("  cause="+e.getCause());
      e.printStackTrace();
    } catch ( IOException e ) {
      System.out.println("IOException");
      e.printStackTrace();
    } catch ( InterruptedException e ) {
      System.out.println("InterruptedException");
      e.printStackTrace();
    }

  }

}

